/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-08 00:28
**/

#include<bits/stdc++.h>
using namespace std;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;

ll N;
vector<cp> v;

lf cross ( cp a , cp b) { return ( conj (a) * b) . imag () ; }
bool is_upper(const cp &c){
    return imag(c) > 0 or (imag(c) == 0 and real(c) >= 0);
}
bool cmp_ang(const cp &l, const cp &r) {
    bool x = is_upper(l), y = is_upper(r);
    return x == y ? cross(l, r) > 0 : x;
} // doing this complex logic, because arg (atan2) is slow

bool cmp_bottomleft(const cp &l, const cp &r) {
  return pair(imag(l), real(l)) < pair(imag(r), real(r));
}

void solve(){
    cin >> N;
    ll a, b, c, d, x, y;
    cp s {0,0}, z, zero = {0,0};
    for (int i = 0; i < N; ++i) {
        cin >> a >> b >> c >> d;
        z = {a - b, c - d};
        if(z == zero) continue;
        v.emplace_back(z);
        v.emplace_back(-z);
        if (not is_upper(z))
            s += z;
	}

    sort(begin(v), end(v), cmp_ang);

    lf ans = norm(s);
    for (auto dir: v) {
        s += dir;
        ans = max(ans, norm(s));
    }
    cout << ans << endl;
}

int main(){
    ios_base::sync_with_stdio(0);
    cout << setprecision(12);
    cin.tie(0);

    solve();
}
